%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
assert_isequal(nargin('ismissing'), 1);
assert_isequal(nargout('ismissing'), 1);
%=============================================================================
A = ["Nel", NaN, "son"];
R = ismissing(A);
REF = [false, true, false];
assert_isequal(R, REF);
%=============================================================================
B = [1 2 NaN Inf];
R = ismissing(B);
REF = [false false true false];
assert_isequal(R, REF);
%=============================================================================
C = 'Nel son';
R = ismissing(C);
REF = [false false false true false false false];
assert_isequal(R, REF);
%=============================================================================
D = {'Nel' '' 'son'};
R = ismissing(D);
REF = [false true false];
assert_isequal(R, REF);
%=============================================================================
