%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
TEST_DIR = [tempdir(), 'f2c'];
mkdir(TEST_DIR);
DEST_FILE = [TEST_DIR, '/dgemm.c'];
REF_FILE = [modulepath(nelsonroot(),'f2c','root'), '/tests/dgemm.c'];
if isfile(DEST_FILE)
  rmfile(DEST_FILE);
end
copyfile([modulepath(nelsonroot(),'f2c','root'), '/tests/dgemm.f'], [TEST_DIR, '/dgemm.f'])
f2c([TEST_DIR, '/dgemm.f'], TEST_DIR);
DEST_FILE = [TEST_DIR, '/dgemm.c'];
assert_istrue(isfile(DEST_FILE));
R = fileread(DEST_FILE, 'char', 'native');
REF = fileread(REF_FILE,'char', 'native');
assert_isequal(R, REF);
rmfile(DEST_FILE);
%=============================================================================

