%=============================================================================
% Copyright (c) 2016-present Allan CORNET (Nelson)
%=============================================================================
% This file is part of the Nelson.
%=============================================================================
% LICENCE_BLOCK_BEGIN
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU Lesser General Public
% License as published by the Free Software Foundation; either
% version 2.1 of the License, or (at your option) any later version.
%
% Alternatively, you can redistribute it and/or
% modify it under the terms of the GNU General Public License as
% published by the Free Software Foundation; either version 2 of
% the License, or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU Lesser General Public License for more details.
%
% You should have received a copy of the GNU Lesser General Public
% License along with this program. If not, see <http://www.gnu.org/licenses/>.
% LICENCE_BLOCK_END
%=============================================================================
assert_isequal(nargin('cosh'), 1);
assert_isequal(nargout('cosh'), 1);
%=============================================================================
assert_isequal(cosh(NaN), NaN);
assert_isequal(cosh(Inf), Inf);
assert_isequal(cosh(-Inf), Inf);
%=============================================================================
A = rand(100, 100);
y1 = cosh(A * i);
y2 = complex(cos(A));
assert_isapprox(y1, y2, 1e-4);
%=============================================================================
A = rand(3, 3, 3);
y1 = cosh(complex(zeros(3, 3, 3), A));
y2 = complex(cos(A));
assert_isapprox(y1, y2, 1e-4);
%=============================================================================
A = cosh(0);
REF = 1;
assert_isequal(A, REF);
%=============================================================================
A = cosh(sparse(zeros(3,3)));
REF = sparse(ones(3, 3));
assert_isequal(A, REF);
%=============================================================================
assert_checkerror('cosh(''a'')', [_('Undefined function ''cosh'' for input arguments of type '''), class('a'), '''.']);
%=============================================================================
